MEMORY
{
  /* NOTE 1 K = 1 KiBi = 1024 bytes */
  BOOT2                             : ORIGIN = 0x10000000, LENGTH = 0x100
  BOOTLOADER_STATE                  : ORIGIN = 0x10006000, LENGTH = 4K
  FLASH                             : ORIGIN = 0x10007000, LENGTH = 512K - 4K
  PROGRAM_INFO                      : ORIGIN = 0x10086000, LENGTH = 4K
  DFU                               : ORIGIN = 0x10087000, LENGTH = 516K
  RAM                               : ORIGIN = 0x20000000, LENGTH = 256K
}

__bootloader_flash_start = ORIGIN(BOOT2);

__bootloader_state_start = ORIGIN(BOOTLOADER_STATE) - ORIGIN(BOOT2);
__bootloader_state_end = ORIGIN(BOOTLOADER_STATE) + LENGTH(BOOTLOADER_STATE) - ORIGIN(BOOT2);

__bootloader_active_start = ORIGIN(FLASH) - ORIGIN(BOOT2);
__bootloader_active_end = ORIGIN(FLASH) + LENGTH(FLASH) - ORIGIN(BOOT2);

__bootloader_dfu_start = ORIGIN(DFU) - ORIGIN(BOOT2);
__bootloader_dfu_end = ORIGIN(DFU) + LENGTH(DFU) - ORIGIN(BOOT2);
